b5ab052e180164e4d010fbccebd1bbc5af297fea
[build-farm.git] / build_test.fns
1 #!/bin/sh -*- mode: shell-script; -*-
2
3 # build_farm -- distributed build/test architecture for samba, rsync, etc
4
5 # Copyright (C) 2001 by Andrew Tridgell <tridge@samba.org>
6 # Copyright (C) 2001 by Andrew Bartlett <abartlet@samba.org>
7 # Copyright (C) 2001, 2003 by Martin Pool <mbp@samba.org>
8
9 # default maximum runtime for any command
10 MAXTIME=25200 # 7 hours
11 SMBD_MAXTIME=18000 # 5 hours for a samba process ..
12 # default maximum memory size (100M) for any command
13 MAXMEM=100000
14 RUN_FROM_BUILD_FARM=yes
15 export RUN_FROM_BUILD_FARM
16 export MAXTIME SMBD_MAXTIME
17
18 deptrees="";
19
20 build_test_fns_id='$Id$'
21
22 copy_dir() {
23         Tsrc=$1
24         Tdst=$2
25         pwd
26         echo rsync -a --delete $Tsrc/ $Tdst
27         rsync -a --delete $Tsrc/ $Tdst || return 1
28         return 0
29 }
30
31 #############################
32 # build a signature of a tree, used to see if we
33 # need to rebuild 
34 #############################
35
36 sum_tree() {
37         sum_tree_test_root=$1
38         sum_tree_tree=$2
39         sum_tree_sum=$3
40         sum_tree_scm=$4
41         find $sum_tree_test_root/$sum_tree_tree -type f -print | grep -v version.h | sort | xargs sum > $sum_tree_sum
42         sum build_test build_test.fns >> $sum_tree_sum
43
44         if [ -f "$host.fns" ]; then
45                 sum $host.fns >> $sum_tree_sum
46         else
47                 sum generic.fns >> $sum_tree_sum
48         fi
49
50         if [ -f "$test_root/$tree.$scm" ]; then
51                 sum "$test_root/$tree.$scm" >> $sum_tree_sum
52         fi
53
54         for d in $deptrees; do
55                 dscm=`choose_scm "$d"`
56                 if [ -f "$test_root/$d.$dscm" ]; then
57                 sum "$test_root/$d.$dscm" >> $sum_tree_sum
58                 fi
59         done
60 }
61
62 #############################
63 # send the logs to the master site
64 #############################
65
66 send_logs() {
67         if [ "$nologreturn" = "yes" ]; then
68                 echo "skipping log transfer"
69         else
70                 log="$1"
71                 err="$2"
72                 shift
73                 shift
74                 chmod 0644 "$log" "$err"
75
76                 # xargs -i is implemented differently or not at all.
77                 # GNU xargs did not implement "-I" until 4.2.9:
78                 xargs --version 2>&1 | grep "^GNU xargs" > /dev/null
79                 status=$?
80                 if [ x"$status" = x"0" ]; then
81                         XARGS_IS_GNU=yes
82                 fi
83
84                 if [ x"$XARGS_IS_GNU" = x"yes" ]; then
85                         XARGS_I="xargs -i"
86                 else
87                         XARGS_I="xargs -I '{}'"
88                 fi
89
90                 find $log -size +40000 | $XARGS_I sh -c 'dd if={} bs=1024 count=20000 of={}.tmp && mv {}.tmp {} &&  echo "\n***LOG TRUNCATED***" >> {}'
91                 find $err -size +40000 | $XARGS_I sh -c 'dd if={} bs=1024 count=20000 of={}.tmp && mv {}.tmp {} &&  echo "\n***LOG TRUNCATED***" >> {}'
92
93                 rsync $* -c -q --password-file=.password -z --timeout=200 \
94                         "$log" "$err" $host@build.samba.org::build_farm_data/
95         fi
96 }
97
98 #############################
99 # send the logs when they haven't changed
100 # the aim is to just update the servers timestamp.
101 # sending with a very large rsync block size does this
102 # with minimal network traffic
103 #############################
104
105 send_logs_skip() {
106         touch "$1" "$2"
107         send_logs "$1" "$2" -B 10000000
108 }
109
110 ############################
111 # fetch the latest copy of the tree
112 ############################
113
114 fetch_tree() {
115         if [ "$norsync" = "yes" ]; then
116                 echo "skipping tree transfer"
117         else
118                 fetchtree=$1
119                 if rsync --exclude=autom4te.cache/ --exclude=.svn/ --exclude=.git/ \
120                         --delete-excluded -q --partial --timeout=200 -ctrlpz --delete --ignore-errors \
121                         samba.org::ftp/unpacked/$fetchtree/ $test_root/$fetchtree; then
122                         echo "transferred $fetchtree OK"
123                 else
124                         echo "transfer of $fetchtree failed code $?"
125                         return 1
126                 fi
127         fi
128         return 0
129 }
130
131 ############################
132 # fetch the latest copy of the rev meta info
133 ############################
134
135 fetch_revinfo() {
136         tree=$1
137         scm=$2
138
139         test -z "$scm" && return 1
140         test x"$scm" = x"unknown" && return 1
141         test x"$scm" = x"cvs" && return 1
142
143         if [ "$norsync" = "yes" ]; then
144                 echo "skipping .revinfo.$scm transfer"
145         else
146                 if [ -r $test_root/$tree.$scm ]; then
147                         [ -f $test_root/$tree.$scm.old ] && rm -f $test_root/$tree.$scm.old
148                         [ -f $test_root/$tree.$scm ] && mv $test_root/$tree.$scm $test_root/$tree.$scm.old
149                 fi
150                 rsync -q --timeout=200 -clz --ignore-errors \
151                         samba.org::ftp/unpacked/$tree/.revinfo.$scm $test_root/$tree.$scm
152         fi
153         if [ -r $test_root/$tree.$scm ]; then
154                 return 0;
155         fi
156         return 1
157 }
158
159 ############################
160 # choose the scm that is used for the given project
161 ############################
162
163 choose_scm() {
164         tree=$1
165
166         case "$tree" in
167                         samba* | rsync | libreplace | talloc | tdb | ldb | pidl | ccache* | waf*)
168                         echo "git"
169                                 return 0
170                         ;;
171         esac
172
173         echo "svn"
174         return 0
175 }
176
177 locknesting=0
178
179 ############################
180 # grab a lock file. Not atomic, but close :)
181 # tries to cope with NFS
182 ############################
183
184 lock_file() {
185                 if [ -z "$lock_root" ]; then
186                         lock_root=`pwd`;
187                 fi
188
189                 lckf="$lock_root/$1"
190                 machine=`cat "$lckf" 2> /dev/null | cut -d: -f1`
191                 pid=`cat "$lckf" 2> /dev/null | cut -d: -f2`
192
193                 if [ "$pid" = "$$" ]; then
194                         locknesting=`expr $locknesting + 1`
195                         echo "lock nesting now $locknesting"
196                         return 0
197                 fi
198
199                 if test -f "$lckf"; then
200                         test x$machine = x$host || {
201                                 echo "lock file $lckf is valid for other machine $machine"
202                                 return 1
203                         }
204
205                         kill -0 $pid && {
206                                 echo "lock file $lckf is valid for process $pid"
207                                 return 1
208                         }
209
210                         echo "stale lock file $lckf for $machine:$pid"
211                         cat "$lckf"
212                         /bin/rm -f "$lckf"
213                 fi
214                 echo "$host:$$" > "$lckf"
215                 return 0
216 }
217
218 ############################
219 # unlock a lock file
220 ############################
221
222 unlock_file() {
223         if [ -z "$lock_root" ]; then
224                 lock_root=`pwd`;
225         fi
226         if [ "$locknesting" != "0" ]; then
227                 locknesting=`expr $locknesting - 1`
228                 echo "lock nesting now $locknesting"
229         else 
230                 lckf="$lock_root/$1"
231                 /bin/rm -f "$lckf"
232         fi
233 }
234
235 ############################
236 # run make, and print trace
237 ############################
238
239 do_make() {
240         # work out correct make command
241         case "$tree" in
242             waf*)
243                 MAKECOMMAND="./waf"
244                 ;;
245             *)
246                 MAKECOMMAND="$MAKE"
247                 if [ x"$MAKECOMMAND" = x ]; then
248                     MAKECOMMAND=make
249                 fi
250                 ;;
251         esac
252
253         MMTIME=$MAXTIME
254         # some trees don't need as much time
255         case "$tree" in
256                 rsync | tdb | talloc | libreplace | ccache* | waf*)
257                         if [ "$compiler" != "checker" ]; then
258                                 MMTIME=`expr $MMTIME / 5`
259                         fi
260                 ;;
261         esac
262
263         # special build for some trees
264         case "$tree" in
265             waf*)
266                 ./waf distclean && ./waf configure build
267                 ;;
268         esac
269
270
271         for t in $*; do
272                 if [ x"$BUILD_FARM_NUM_JOBS" = x ]; then
273                         echo "$MAKECOMMAND $t"
274                         $builddir/timelimit $MMTIME "$MAKECOMMAND" "$t"
275                         status=$?
276                 else
277                         # we can parallelize everything and all targets
278                         if [ x"$t" = xeverything ] || [ x"$t" = xall]; then
279                                 echo "$MAKECOMMAND" "-j$BUILD_FARM_NUM_JOBS"  "$t"
280                                 $builddir/timelimit $MMTIME "$MAKECOMMAND" "-j$BUILD_FARM_NUM_JOBS"  "$t"
281                                 status=$?
282                         else
283                                 echo "$MAKECOMMAND $t"
284                                 $builddir/timelimit $MMTIME "$MAKECOMMAND" "$t"
285                                 status=$?
286                         fi
287                 fi
288
289                 if [ $status != 0 ]; then
290                         case "$t" in
291                                 test|check|installcheck)
292                                         ;;
293                                 *)
294                                         #run again with V=1, so we see failed commands
295                                         $builddir/timelimit $MMTIME "$MAKECOMMAND" "$t" V=1
296                                         status=$?
297                                         ;;
298                         esac
299                 fi
300
301                 if [ $status != 0 ]; then
302                         return $status;
303                 fi
304
305         done
306
307         return 0
308 }
309
310
311 ############################
312 # do the coverage report
313 ############################
314
315 action_lcovreport() {
316         if [ "$LCOV_REPORT" = "yes" ]; then
317                 case "$tree" in
318                 lorikeet-heimdal*)
319                         lcov --directory $builddir --capture --output-file $builddir/$tree.lcov.info
320                         ;;
321                 samba_3_master*)
322                         lcov --base-directory $builddir --directory $builddir/.. --capture --output-file $builddir/$tree.lcov.info
323                         ;;
324                 samba_4*)
325                         # rm -f heimdal/lib/*/{lex,parse,sel-lex}.{gcda,gcno}
326                         lcov --base-directory $builddir --directory $builddir/.. --capture --output-file $builddir/$tree.lcov.info
327                         ;;
328                 *)
329                         lcov --base-directory $builddir --directory $builddir --capture --output-file $builddir/$tree.lcov.info
330                         ;;
331                 esac
332                 genhtml -o $builddir/coverage $builddir/$tree.lcov.info
333                 rc=$?
334                 echo "return code: $rc"
335         else
336                 echo "LCOV_REPORT not set and lcovreport asked"
337                 echo "Most probably an error please fix !"
338                 return 1
339         fi
340 }
341
342
343 ############################
344 # configure the tree
345 ############################
346
347 action_configure() {
348         # special handling for some trees
349         case "$tree" in
350             waf*)
351                 $builddir/timelimit $MAXTIME ./waf configure
352                 cstatus=$?
353                 echo "CONFIGURE STATUS: $cstatus"
354                 return $cstatus
355                 ;;
356         esac
357
358         if [ ! -x $srcdir/configure -a -r $srcdir/Makefile.PL ]; then
359                 perl $srcdir/Makefile.PL PREFIX="$prefix"
360                 cstatus=$?
361                 echo "CONFIGURE STATUS: $cstatus"
362                 return $cstatus;
363         fi
364
365         if [ ! -x $srcdir/configure ]; then
366                 ls -l $srcdir/configure
367                 echo "$srcdir/configure is missing"
368                 cstatus=255
369                 echo "CONFIGURE STATUS: $cstatus"
370                 return $cstatus;
371         fi
372
373         echo "CFLAGS=$CFLAGS"
374         echo configure options: $config_and_prefix
375         echo CC="$CCACHE $compiler" $srcdir/configure $config_and_prefix
376
377         CC="$CCACHE $compiler"
378         export CC
379         $builddir/timelimit $MAXTIME $srcdir/configure $config_and_prefix
380         cstatus=$?
381
382         if [ x"$cstatus" != x"0" ]; then
383                 if [ -f config.log ]; then
384                         echo "contents of config.log:"
385                         cat config.log
386                 fi
387
388                 # Waf style
389                 if [ -f bin/config.log ]; then
390                         echo "contents of config.log:"
391                         cat bin/config.log
392                 fi
393         fi
394         echo "CONFIGURE STATUS: $cstatus"
395         return $cstatus
396 }
397
398 ############################
399 # show the configure log
400 ############################
401
402 action_config_log() {
403
404         log_files="config.log bin/config.log"
405         for f in $log_files; do
406                 if [ -f $f ]; then
407                         echo "contents of config.log:"
408                         cat $f
409                         return 0
410                 fi
411         done
412         return 0
413 }
414
415 ############################
416 # show the config.h
417 ############################
418
419 action_config_header() {
420         hdr_files="config.h include/config.h include/autoconf/config.h bin/default/config.h bin/default/include/config.h bin/default/source3/include/config.h"
421         for h in $hdr_files; do
422                 if [ -f $h ]; then
423                         echo "contents of $h:"
424                         cat $h
425                         return 0
426                 fi
427         done
428
429         return 0
430 }
431
432
433
434 ############################
435 # build the tree
436 ############################
437 action_build() {
438         case "$tree" in
439         samba_4*)
440                 do_make everything
441                 bstatus=$?
442                 ;;
443         samba_3*)
444                 do_make everything torture
445                 bstatus=$?
446                 ;;
447         waf*)
448                 do_make build
449                 bstatus=$?
450                 ;;
451         *)
452                 do_make all
453                 bstatus=$?
454                 ;;
455         esac
456
457         echo "BUILD STATUS: $bstatus"
458
459         return $bstatus
460 }
461
462 ############################
463 # show static analysis results
464 ############################
465
466 action_cc_checker() {
467
468         # default to passing the cc_checker
469         cccstatus=0
470
471         if [ -f ibm_checker.out ]; then
472                 cat ibm_checker.out
473                 cccstatus=`cat ibm_checker.out | grep '^\-\- ' | wc -l`
474         fi
475
476         echo "CC_CHECKER STATUS: $cccstatus"
477         return $cccstatus;      
478 }
479
480 ############################
481 # install the tree
482 ############################
483
484 action_install() {
485         if [ -d $prefix ]; then
486                 if [ "$noclean" != "yes" ]; then
487                         rm -rf $prefix
488                 fi
489         fi
490
491         do_make install
492         istatus=$?
493         echo "INSTALL STATUS: $istatus"
494         return $istatus;
495 }
496
497 ############################
498 # test the tree
499 action_test_samba() {
500         do_make test
501         totalstatus=$?
502
503         # if we produced a test summary then show it
504         [ -f st/summary ] && {
505                 echo "TEST SUMMARY"
506                 cat st/summary
507         }
508
509         return "$totalstatus"
510 }
511
512 action_test_generic() {
513         CC="$compiler"
514         export CC
515         do_make installcheck
516         totalstatus=$?
517         echo "TEST STATUS: $totalstatus"
518         return "$totalstatus"
519 }
520
521 action_test_lorikeet_heimdal() {
522         CC="$compiler"
523         export CC
524         SOCKET_WRAPPER_DIR=`pwd`/sw
525         mkdir $SOCKET_WRAPPER_DIR
526         export SOCKET_WRAPPER_DIR
527         do_make check
528         totalstatus=$?
529         SOCKET_WRAPPER_DIR=
530         export SOCKET_WRAPPER_DIR
531         echo "TEST STATUS: $totalstatus"
532         return "$totalstatus"
533 }
534
535
536 #############################
537 # attempt some basic tests of functionaility
538 # starting as basic as possible, and getting incresingly complex
539 #############################
540
541 action_test() {
542         # Samba needs crufty code of its own for backward
543         # compatiblity.  I think a better way to do this in the future
544         # is to just call 'make installcheck'.
545         case "$tree" in
546         samba*|smb-build|pidl)
547                 action_test_samba
548                 ;;
549         lorikeet-heimdal*)
550                 action_test_lorikeet_heimdal
551                 ;;
552         *)
553                 action_test_generic
554                 ;;
555         esac
556 }
557
558 ###########################
559 # do a test build of a particular tree
560 # This is the master function called by generic.fns or
561 # host.fns
562 ###########################
563
564 test_tree() {
565         tree=$1
566         source=$2
567         compiler="$3"
568         shift
569         shift
570         shift
571         echo "Starting to deal with tree $tree with compiler $compiler"
572         if [ "$compiler" = "gcc" ] && [ "$tree" != "ccache" ] && [ "$tree" != "ccache-maint" ] && ccache -V > /dev/null 2>/dev/null; then
573                 CCACHE="ccache"
574                 export CCACHE
575         else
576                 CCACHE=""
577         fi
578
579         # limit our resource usage
580         ulimit -t $MAXTIME 2> /dev/null
581
582         # max mem size 100M
583         ulimit -m $MAXMEM 2> /dev/null
584
585         # max file size 100M
586         # darn, this affects sparse files too! disable it
587         # ulimit -f 100000 2> /dev/null
588
589         # try and limit the number of open files to 250. That means we'll discover
590         # fd leaks faster
591         ulimit -n 250 2> /dev/null
592
593         # Keep stuff private
594         umask 077
595
596         if [ -z "$test_root" ]; then
597                 test_root=`pwd`
598         fi
599
600         log="build.$tree.$host.$compiler.log"
601         err="build.$tree.$host.$compiler.err"
602         sum="build.$tree.$host.$compiler.sum"
603         lck="build.$tree.lck"
604                 srcdir="$test_root/$tree/$source"
605
606         lock_file "$lck" || {
607                 return
608         }
609
610         # work out what other trees this package depends on
611         deptrees=""
612         case "$tree" in
613                 samba-gtk)
614                 deptrees="samba_4_0_test"
615                 ;;
616         esac
617
618         scm=`choose_scm "$tree"`
619
620         # pull the entries, if any
621         # Remove old .svn or .git files
622         # Move the current .svn org .git to .svn.old or
623         # .git.old then fetch the new from rsync
624         if fetch_revinfo "$tree" "$scm"; then
625                 for d in $deptrees; do
626                         # If there is dependency substree(s) we add info
627                         # from the dependency tree so that we
628                         # can rebuild in case one of them has changed
629                         dscm=`choose_scm "$d"`
630                         if [ -f "$test_root/$d.$dscm" ]; then
631                                 if [ "$d" != "$tree" ]; then
632                                         cat "$test_root/$d.$dscm" >> $test_root/$tree.$scm
633                                 fi
634                         fi
635                 done
636                 [ -f $test_root/$tree.$compiler.$scm.old ] && rm -f $test_root/$tree.$compiler.$scm.old
637                 [ -f $test_root/$tree.$compiler.$scm ] && mv $test_root/$tree.$compiler.$scm $test_root/$tree.$compiler.$scm.old
638                 [ -f $test_root/$tree.$scm ] && cp $test_root/$tree.$scm $test_root/$tree.$compiler.$scm
639
640                 if [ -f $test_root/$tree.$compiler.$scm.old ] && \
641                                 cmp $test_root/$tree.$compiler.$scm $test_root/$tree.$compiler.$scm.old > /dev/null; then
642
643                         echo "skip: $tree.$compiler nothing changed in $scm"
644                         cd $test_root
645                         send_logs_skip "$log" "$err"
646                         unlock_file "$lck"
647                         return
648                 fi
649         fi
650
651         # pull the tree
652         fetch_tree "$tree" || {
653                 cd $test_root
654                 unlock_file "$lck"
655                 return
656         }
657
658         # check for essential files
659         case "$tree" in
660             pidl)
661                 # no generated files
662                 ;;
663             waf*)
664                 if [ ! -x $srcdir/waf ]; then
665                     echo "skip: $tree.$compiler waf not present, try again next time!"
666                     cd $test_root
667                     unlock_file "$lck"
668                     return
669                 fi
670                 ;;
671             *)
672                 if [ ! -x $srcdir/configure ]; then
673                     echo "skip: $tree.$compiler configure not present, try again next time!"
674                     cd $test_root
675                     unlock_file "$lck"
676                     return
677                 fi
678                 ;;
679         esac
680
681         echo "Starting build of $tree.$compiler in process $$ at `date`"
682
683
684         # Parameters for the build depending on the tree
685         case "$tree" in
686                 *)
687                         builddir=$srcdir
688                         export builddir
689                         ;;
690         esac
691
692         #Fix the user
693         if [ ! x$USER = x"" ]; then
694                 whoami=$USER
695         else 
696                 if [ ! x$LOGNAME = x"" ]; then
697                         whoami=$LOGNAME
698                 else
699                         whoami=build
700                 fi
701         fi
702
703         # build the timelimit utility
704         echo "Building timelimit"
705         mkdir -p $builddir
706         echo $compiler $TIMELIMIT_FLAGS -o $builddir/timelimit $test_root/timelimit.c
707         $compiler $TIMELIMIT_FLAGS -o $builddir/timelimit $test_root/timelimit.c || exit 1
708
709         # build the killbysubdir utility
710         echo "Building killbysubdir"
711         echo $compiler -o $builddir/killbysubdir $test_root/killbysubdir.c
712         $compiler -o $builddir/killbysubdir $test_root/killbysubdir.c
713
714         prefix="$test_root/prefix/$tree.$compiler"
715         mkdir -p "$prefix"
716
717         # This can be defined in <host>.fns files
718         sw_config=$config
719
720         case "$tree" in
721         lorikeet-heimdal)
722                 sw_config="$config --enable-socket-wrapper"
723                 ;;
724         samba_4*)
725                 sw_config="$config --enable-socket-wrapper"
726                 sw_config="$sw_config --enable-nss-wrapper"
727                 sw_config="$sw_config --enable-uid-wrapper"
728                 ;;
729         samba_3*)
730                 sw_config="$config --enable-socket-wrapper"
731                 sw_config="$sw_config --enable-nss-wrapper"
732                 ;;
733         samba-gtk)
734                 PKG_CONFIG_PATH="$test_root/prefix/samba_4_0_test.$compiler/lib/pkgconfig"
735                 export PKG_CONFIG_PATH
736                 ;;
737         *)
738                 testsuite=testsuite
739                 ;;
740         esac
741
742         if [ "$LCOV_REPORT" = "yes" ]; then
743                 GCOV_FLAGS="--coverage"
744                 CFLAGS="$CFLAGS $GCOV_FLAGS" 
745                 LDFLAGS="$LDFLAGS $GCOV_FLAGS" 
746                 export CFLAGS LDFLAGS
747         fi
748
749         config_and_prefix="$sw_config --prefix=$prefix"
750
751         # see if we need to rebuild
752         sum_tree $test_root $tree $sum $scm
753         echo "CFLAGS=$CFLAGS $config_and_prefix" >> $sum
754
755         if [ -f "$sum.old" ] && cmp "$sum" "$sum.old" > /dev/null; then
756                 echo "skip: $tree.$compiler nothing changed"
757                 cd $test_root
758                 send_logs_skip "$log" "$err"
759                 unlock_file "$lck"
760                 echo "Ending build of $tree.$compiler in process $$ at `date`"
761                 return
762         fi
763
764         # we do need to rebuild - save the old sum
765         [ -f $sum.old ] && /bin/rm -f $sum.old
766         mv $sum $sum.old
767
768         #Action == what to do ie. configure config_log ...
769         actions="$*"
770
771         if [ "$actions" = "" ]; then
772                 actions="configure config_log config_header build install test"
773         fi
774
775         # start the build
776         (
777         {
778                 # we all want to be able to read the output...
779                 LANG=C
780                 export LANG
781
782                 uname -a
783
784                 echo ""
785                 echo "build_test                  : $build_test_id"
786                 echo "build_test.fns      : $build_test_fns_id"
787                 echo "local settings file : $build_test_settings_local_file"
788                 echo "local functions file: $build_test_fns_local_file"
789                 echo "used .fns file      : $build_test_used_fns_file"
790                 echo ""
791
792                 # we need to be able to see if a build farm machine is accumulating
793                 # stuck processes. We do this in two ways, as we don't know what style
794                 # of ps it will have
795                 ps xfuw 2> /dev/null
796                 ps -fu $USER 2> /dev/null
797
798                 echo "building $tree with CC=$compiler on $host at "`date`
799                 echo "builddir=$builddir"
800                 echo "prefix=$prefix"
801
802                 echo "Showing limits"
803                 ulimit -a 2> /dev/null
804
805                 # the following is for non-samba builds only
806                 if [ "$scm" = "svn" -a -r $test_root/$tree.svn ]; then
807                         h_rev=`grep 'Revision: ' $test_root/$tree.svn | cut -d ':' -f2 | cut -d ' ' -f2 | sed 1q`
808                         if [ -n "$h_rev" ]; then
809                                 echo "HIGHEST SVN REVISION: $h_rev"
810                         fi
811                         rev=`grep 'Last Changed Rev: ' $test_root/$tree.svn | cut -d ':' -f2 | cut -d ' ' -f2 | sed 1q`
812                         if [ -n "$rev" ]; then
813                         echo "BUILD REVISION: $rev"
814                         fi
815                 elif [ "$scm" = "git" -a -r $test_root/$tree.git ]; then
816                         csha1=`cat $test_root/$tree.git |head -3 | tail -1`
817                         if [ -n "$csha1" ]; then
818                                 echo "BUILD COMMIT REVISION: $csha1"
819                         fi
820                         cdate=`cat $test_root/$tree.git |head -4 | tail -1`
821                         if [ -n "$cdate" ]; then
822                                 echo "BUILD COMMIT DATE: $cdate"
823                         fi
824                         ctime=`cat $test_root/$tree.git |head -2 | tail -1`
825                         if [ -n "$ctime" ]; then
826                                 echo "BUILD COMMIT TIME: $ctime"
827                   fi
828                 fi
829
830                 if [ -x $builddir/killbysubdir ]; then
831                         echo "$builddir/killbysubdir $builddir in `pwd`"
832                         $builddir/killbysubdir $builddir
833                 fi
834
835                 for action in $actions; do
836
837                         echo Running action $action
838
839                         date
840
841                         cd $builddir || exit 1
842                         export srcdir
843                         df .
844                         mount
845                         vmstat
846
847                         if [ "x$PREHOOKS" != "x" ]; then
848                                 for hooks in $PREHOOKS; do
849                                         if [ "x$hooks" = "x$action" ]; then
850                                                 ( prehook_$action )
851                                         fi
852                                 done
853                         fi
854
855                         ( action_$action )
856                         action_status=$?
857
858                         if [ "x$POSTHOOKS" != "x" ]; then
859                                 for hooks in $POSTHOOKS; do
860                                         if [ "x$hooks" = "x$action" ]; then
861                                                 ( posthook_$action )
862                                         fi
863                                 done
864                         fi
865
866                         df .
867
868                         if [ $action_status != 0 ]; then
869                                 echo "ACTION FAILED: $action";
870                                 echo " return code $action_status $action";
871                         else
872                                 echo "ACTION PASSED: $action";
873                         fi
874
875                         if [ $action_status != 0 ]; then 
876                                 break;
877                         fi
878                 done
879
880
881                 if [ "$noclean" = "yes" ]; then
882                         echo cleanup skipped!
883                 else
884                         echo cleaning up
885                         do_make clean
886                 fi
887                 date
888         } 3>&2 2>&1 1>&3 | tee "$err"
889         ) > "$log" 2>&1
890         # be aware the above channel swap may sometimes result in unordered
891         # stdout/stderr merge
892
893         if [ "$LCOV_REPORT" = "yes" ]; then
894                 chmod u=rwX,g=rX,o=rX -R $builddir/coverage
895                 rsync -rct -q --password-file=.password -z --timeout=200 \
896                         $builddir/coverage/ $host@build.samba.org::lcov_data/$host/$tree/
897         fi
898
899         cd $test_root
900
901         /bin/rm -rf $prefix
902         # send the logs to the master site
903         send_logs "$log" "$err"
904
905         # cleanup
906         echo "Ending build of $tree.$compiler in process $$ at `date`"
907         unlock_file "$lck"
908 }
909
910 #########################################################
911 # if you want to build only one project at a time
912 # add 'global_lock' after 'per_run_hook' and
913 # 'global_unlock' to the end of the file
914 #########################################################
915
916 global_lock() {
917         lock_file "global.lck" || {
918                 exit 0
919         }
920 }
921
922 global_unlock() {
923         unlock_file "global.lck"
924 }
925
926 delete_old_tree() {
927         otree=$1
928         test -z "$otree" && return 0;
929
930         rm -rf $otree
931         rm -rf $otree.svn
932         rm -rf $otree.*.svn
933         rm -rf $otree.git
934         rm -rf $otree.*.git
935         rm -rf build.$otree.*
936 }
937
938 # this is a special fn that allows us to add a "special" hook to the build
939 # farm that we want to do to the build farm. never leave it empty. instead,
940 # use ":" as the fn body.
941 per_run_hook() {
942         # kill old processes on systems with a known problem
943         case $host in
944         nohost)
945                 echo "just a placeholder";
946                 ;;
947         deckchair)
948                 rm -f deckchair.fns
949                 ;;
950         esac
951
952         # trim the log if too large
953         if [ "`wc -c < build.log`" -gt 2000000 ]; then
954         rm -f build.log
955         fi
956
957         old_trees="web popt distcc samba-gtk smb-build lorikeet-heimdal samba_3_2"
958         old_trees="$old_tree samba_3_2_test samba4 samba_4_0_waf samba_4_0_waf.metze"
959         old_trees="$old_tree samba_3_X_test samba_3_X_devel samba_3_X_devel samba_3_waf"
960         for d in $old_trees; do
961                 delete_old_tree $d
962         done
963 }
964
965
966 ######################################################
967 # main code that is run on each call to the build code
968 ######################################################
969 rsync --timeout=200 -q -az build.samba.org::build_farm/*.c .
970
971
972 # build.log can grow to an excessive size, trim it beyond 50M
973 if [ -f build.log ]; then
974         find build.log -size +100000 -exec /bin/rm '{}' \;
975 fi